
DEFINE MAX_LEVEL INTEGER,
	GRPHIER_START_ROW               SMALLINT,       # start display hier row
        GRTYPE_COL                      SMALLINT,       # display hier grtyp col
        GRID_COL                        SMALLINT,       # display hier grid col
        GRNAME1_COL                     SMALLINT,       # display hier grnm1 col
        GRNAME2_COL                     SMALLINT,       # display hier grnm2 col
        GRLEVEL_COL                     SMALLINT       # display hier grlev col
DEFINE        group_hierarchy ARRAY[10] OF RECORD
                grid                            CHAR(8),
                grname1                         CHAR(25),
                grname2                         CHAR(25),
                grlevel                         CHAR(1),
                grtype                          CHAR(1)
        END RECORD


MAIN

DEFINE
        row		SMALLINT,
        col		SMALLINT,
        testcol		SMALLINT,
        testrow		SMALLINT,
        testmsglen	SMALLINT,
        i		SMALLINT,
        testmsg		CHAR(80),
	blankingchars	CHAR(80),
	string80	CHAR(80),
	longmsg		CHAR(132),
	infotext	CHAR(27),
	t_grid		CHAR(8),
	show_lv_cnt	SMALLINT,
        goingdown	SMALLINT,
	cDown1		CHAR(10),
	cDown2		CHAR(10),
	c		CHAR(1),
	answer		CHAR(1)


	LET cDown1 = "Down"
	LET cDown2 = "Down_"

	LET show_lv_cnt = 0 # start with no levels shown (all blank)
	LET goingdown = 1

	LET testmsg = "This is a message"
	LET testmsglen = LENGTH(testmsg)
	LET testrow = 10
	LET testcol = 51

	LET blankingchars = "0123456789abcdefghijklmnopqrstuvwxy"

	LET longmsg = "012345678901234567890123456789012345678901234567890123456789012345678901234567890123456789"

{! # A4GL !}
{!  IF a4gl_get_ui_mode() > 0 then !}
{!	# send default config file to gui !}
{!	IF aclfgl_sendfile_to_ui("default.4st") THEN END IF !}
{!	CALL ui.Interface.loadActionDefaults("default") !}
{!	CALL ui.Interface.loadStyles("default") !}
{!	CALL ui.Interface.setText("Menu Styles") !}
{!  END IF !}


OPEN WINDOW mainwindow AT 5, 8 WITH FORM "form1"
MENU "Main Menu"
         COMMAND "Row_8_col_12"
	    DISPLAY "Hello from me" AT  8, 12

         COMMAND "Row_12_col_35"
	    DISPLAY "And here also as well" AT  12, 35

         COMMAND "from_start_of_line"
		DISPLAY "This is from the start of the line" at 14, 1

         COMMAND "complete_line"
		DISPLAY longmsg at 15, 1

         COMMAND "null string AT 14,1"
		DISPLAY "" at 14, 1

         COMMAND "Hello World AT 15,12"
		DISPLAY "Hello World" at 15, 12

         COMMAND "null string AT 15,12"
		DISPLAY "" at 15, 12

         COMMAND "null var AT 15,12"
                INITIALIZE testmsg TO NULL
                {LET testmsg = "ends with dbl quote", ""}
                DISPLAY testmsg at 15, 12

         COMMAND "single space AT 15,6"
		DISPLAY " " at 15, 6

         COMMAND "with_vars"
		DISPLAY testmsg clipped at testrow, testcol

         COMMAND "Clear"
		DISPLAY "             " AT  8, 12
		DISPLAY "                     " AT  12, 35

		LET row = testrow
		LET i = 0
		FOR col = testcol TO (testcol + testmsglen -1) STEP 1
			LET i = i + 1
			{DISPLAY blankingchars[i,i] at row, col}
			LET c = blankingchars[i,i]
			DISPLAY c at row, col
		END FOR


		DISPLAY "                                  " at 14, 1
		

		{DISPLAY longmsg[1,80] at 15, 1}
		LET string80 =  longmsg[1,80]
		DISPLAY string80 at 15, 1
	
		DISPLAY "                                                                                " at 15, 1


	COMMAND "WINDOW AT 9,25 WITH 6,30"
		OPEN WINDOW win2 AT 9,25 WITH FORM "form2"
			ATTRIBUTE( BORDER )
		#MENU "bla"
		#BEFORE MENU
			#DISPLAY "Hello"

			DISPLAY "0123467890123467890123467890123456789" AT 1, 1
			DISPLAY "0123467890123467890123467890123456789" AT 2, 1
			DISPLAY "0123467890123467890123467890123456789" AT 3, 1
			DISPLAY "0123467890123467890123467890123456789" AT 4, 1
			DISPLAY "0123467890123467890123467890123456789" AT 5, 1

			DISPLAY "" AT 3, 4

		#COMMAND "Exit"
		#	EXIT MENU
		#END MENU

		PROMPT "close" for char  answer

		CLOSE WINDOW win2


	COMMAND "fgl_drawbox()"

		CALL fgl_drawbox(4,30,19,47)

		LET infotext = "No Selected Destination"
		LET t_grid = "12345678"
		CALL display_info(infotext, t_grid)


	COMMAND "display at in loop"

		LET GRPHIER_START_ROW = 7 + 11

		LET GRTYPE_COL = 2
		LET GRID_COL = 6
		LET GRNAME1_COL = 17
		LET GRNAME2_COL = 44
		LET GRLEVEL_COL = 73

		LET MAX_LEVEL = 3

		FOR i = MAX_LEVEL TO 1 STEP -1
			INITIALIZE group_hierarchy[i].* TO NULL

			# level 1 not blank 
			if show_lv_cnt > 2 AND i == 1 then
				LET group_hierarchy[1].grid = "12345678"
				LET group_hierarchy[1].grname1 = "123456780123456789012345"
				LET group_hierarchy[1].grname2 = "543210987654321098765432"
				LET group_hierarchy[1].grlevel = "1"
				LET group_hierarchy[1].grtype = "G"
			end if

			# level 2 not blank 
			if show_lv_cnt > 1 AND i == 2 then
				LET group_hierarchy[i].grid = "87654321"
				LET group_hierarchy[i].grname1 = "987654321098765432198765"
				LET group_hierarchy[i].grname2 = "567890123456789012345678"
				LET group_hierarchy[i].grlevel = "2"
				LET group_hierarchy[i].grtype = "G"
			end if

			# level 3 not blank 
			if show_lv_cnt > 0 AND i == 3 then
				LET group_hierarchy[i].grid = "11223344"
				LET group_hierarchy[i].grname1 = "abcdefghijklmnopqrstuvwx"
				LET group_hierarchy[i].grname2 = "ABCDEFGHIJKLMNOPQRSTUVWX"
				LET group_hierarchy[i].grlevel = "3"
				LET group_hierarchy[i].grtype = "E"
			end if

		END FOR

		# cycle up/down show_lv_cnt (0 -> MAX_LEVEL -> 0)
		if goingdown = 1 then
			LET show_lv_cnt = show_lv_cnt + 1
			if show_lv_cnt > MAX_LEVEL then
				LET show_lv_cnt = MAX_LEVEL -1
				LET goingdown = 0
			end if
		else
			LET show_lv_cnt = show_lv_cnt - 1
			if show_lv_cnt < 0 then
				LET show_lv_cnt = 1
				LET goingdown = 1
			end if
		end if

		#PROMPT "a prompt fo char before display loop" for char  answer

		CALL display_group_hierarchy()


	COMMAND "Up"
		PROMPT "MENU COMMAND Up selected - Hit Enter" for char  answer


	COMMAND cDown1
		PROMPT "MENU COMMMAD cDown1 [", cDown1 CLIPPED, "] selected - Hit Enter" for char  answer

	COMMAND cDown2
		PROMPT "MENU COMMMAD cDown2 [", cDown2 CLIPPED, "] selected - Hit Enter" for char  answer



         COMMAND "Exit"
            EXIT MENU
      EXIT MENU
END MENU

END MAIN



FUNCTION display_info(lin1, mdest)
define
	lin1		CHAR(27),
	mdest		CHAR(8),
	tsl1		SMALLINT

  	DISPLAY "                           " at 20,48

	LET tsl1 = length(lin1)
	LET tsl1 = 62 - (tsl1 / 2)

	DISPLAY lin1 CLIPPED at 20,tsl1 
	DISPLAY BY NAME mdest

END FUNCTION



FUNCTION display_group_hierarchy()      # display group hierarchy
DEFINE
        gh_idx                  SMALLINT,
        DispRow                 SMALLINT,
        space_string    CHAR(80)

        LET space_string = " "

        FOR gh_idx = 1 TO MAX_LEVEL

                LET DispRow = (GRPHIER_START_ROW + (gh_idx - 1))

                DISPLAY space_string AT DispRow, 1

                DISPLAY group_hierarchy[gh_idx].grtype   AT DispRow, GRTYPE_COL
                DISPLAY group_hierarchy[gh_idx].grid     AT DispRow, GRID_COL
                DISPLAY group_hierarchy[gh_idx].grname1  AT DispRow, GRNAME1_COL
                DISPLAY group_hierarchy[gh_idx].grname2  AT DispRow, GRNAME2_COL
                DISPLAY group_hierarchy[gh_idx].grlevel  AT DispRow, GRLEVEL_COL

        END FOR

END FUNCTION
